﻿#include "CWindow.h"
#include "CDDPro90.h"

#define DEBUGMODE
#include "DEBUG.H"

CWindow		win;
CDDPro90	dd;
float		fX = -128.0f;		// 雲のX座標
int			iTimerCount = 0;	// カウンタ(0～359)

int WINAPI WinMain( HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpszCmdParam,int nCmdShow )
{
	INITDEBUG();
	CLEARDEBUG();

    if( !win.Create(hInstance,L"CDDProSample",TRUE,640,480) ) {
		DEBUG( "ウィンドウエラー\n" );
        return -1;
	}

	// Direct3D構築
	if( !dd.Create(win.hWnd,FALSE,640,480) ) {
		DEBUG( "Direct3D構築エラー\n" );
		return -1;
	}

	// テクスチャのロード
	dd.AddTexture( 0,"SKY.BMP" );
	dd.AddTexture( 1,"SUN.BMP" );
	dd.AddTexture( 2,"CLOUD.TGA" );

	// 切り抜き
	dd.SetPutRange( 0,0,  0, 0, 640, 480 );		// "SKY.BMP" 空
	dd.SetPutRange( 1,1,  0, 0,1024,1024 );		// "SUN.BMP" 太陽
	dd.SetPutRange( 2,2,  0, 0, 256, 180 );		// "CLOUD.TGA" 雲

	// メインループ
	MSG msg;
	while(1) {
		if( PeekMessage(&msg,NULL,0,0,PM_REMOVE) ) {	// プログラム内のメッセージ処理
			if( msg.message==WM_QUIT )
				break;									// ALT+F4が押されたらメインを抜ける
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}

		// カウンタ処理
		iTimerCount++;
		if( iTimerCount>359 )
			iTimerCount = 0;

		// 雲の座標
		fX += 1.0f;
		if( fX>800.0f )
			fX = -128.0f;

		// シーン開始
		dd.DrawBegin();

		// 空
		dd.Put( 0,0,0 );

		// 太陽
		dd.SetBlendOne( TRUE );
		dd.SetPutStatus( 1, 0.5f, 0.8f, (float)((sin(iTimerCount*3.14159f/180)*45)*3.14159/180) );
		dd.Put2( 1,320,240 );
		dd.SetBlendOne( FALSE );

		// 雲
		float mul = (float)sin((double)iTimerCount*4*3.14159/180 ) / 4.0f + 0.75f;		// 拡大縮小(0.5～1.5)
		dd.SetPutStatus( 3, 1.0f, mul );
		dd.Put2( 2,fX,240 );

		// シーン終了・描画
		dd.DrawEnd();

        Sleep(8);										// CPUへのウエイト
    }


	dd.Delete();
	win.Delete();
	
	return 0;
}
